
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "kite_parser.y"

/*****************************************************************************
 * Copyright (c) 2007, Mooneer Salem
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Kite Language organization nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY MOONEER SALEM ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL MOONEER SALEM BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#define KITE_COMPILER
#include "objs/kite_object.h"
#include "kite_vm.h"
#include "../kite-vm-1.0/kite_opcodes.h"

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm

/*
 * Dirty, dirty hack to make yyerror() work with Kite's exception system.
 * Credit: http://www.everything2.com/index.pl?node_id=1509675
 */
#define yyerror( msg )  dirty_yyerror( parm, msg )
void dirty_yyerror(void *, char *);
void checkReserved(void *, char *);

/* 
 * For some weird reason, we had to split the macro out this way
 * in order for the file/line numbering in exceptions to work properly.
 */
extern void *yyget_extra(void *);
extern int yylex(void *, void *, void *);

/* Need to grab dylib path from compiler. TODO: use separate method to manipulate. */
extern char *kite_dylib_path;


/* Line 189 of yacc.c  */
#line 133 "kite_parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IMPORT = 258,
     METHOD = 259,
     SYMBOL_NAME = 260,
     FROM = 261,
     CLASS = 262,
     CONSTRUCT = 263,
     DESTRUCT = 264,
     PROPERTY = 265,
     GLOBAL = 266,
     PLUS = 267,
     MINUS = 268,
     MULTIPLY = 269,
     DIVIDE = 270,
     UNARY_PLUS = 271,
     UNARY_MINUS = 272,
     MAP = 273,
     REDUCE = 274,
     ARRAY_DEREF = 275,
     EQUALS = 276,
     NOT_EQUALS = 277,
     LESS_THAN = 278,
     GREATER_THAN = 279,
     LESS_OR_EQUALS = 280,
     GREATER_OR_EQUALS = 281,
     AND = 282,
     OR = 283,
     NOT = 284,
     STRING_VALUE = 285,
     FLOAT_VALUE = 286,
     INT_VALUE = 287,
     MOD = 288,
     OPERATOR = 289,
     XOR = 290,
     LEFT_SHIFT = 291,
     RIGHT_SHIFT = 292,
     EVAL = 293,
     DECIDE = 294,
     BOOL_VALUE = 295,
     UNTIL = 296,
     WHILE = 297,
     RUN = 298,
     CATCH = 299,
     IS = 300,
     ISOF = 301,
     MAKE = 302,
     METHOD_CALL = 303,
     NULL_VALUE = 304,
     DOCSTRING = 305,
     BREAK = 306,
     CONTINUE = 307,
     RETURN = 308,
     VERSION_KEYWORD = 309,
     REGEX_VALUE = 310,
     REGEX_VALUE_CI = 311,
     ARRAY_SET = 312,
     OPTIONS_SET = 313
   };
#endif
/* Tokens.  */
#define IMPORT 258
#define METHOD 259
#define SYMBOL_NAME 260
#define FROM 261
#define CLASS 262
#define CONSTRUCT 263
#define DESTRUCT 264
#define PROPERTY 265
#define GLOBAL 266
#define PLUS 267
#define MINUS 268
#define MULTIPLY 269
#define DIVIDE 270
#define UNARY_PLUS 271
#define UNARY_MINUS 272
#define MAP 273
#define REDUCE 274
#define ARRAY_DEREF 275
#define EQUALS 276
#define NOT_EQUALS 277
#define LESS_THAN 278
#define GREATER_THAN 279
#define LESS_OR_EQUALS 280
#define GREATER_OR_EQUALS 281
#define AND 282
#define OR 283
#define NOT 284
#define STRING_VALUE 285
#define FLOAT_VALUE 286
#define INT_VALUE 287
#define MOD 288
#define OPERATOR 289
#define XOR 290
#define LEFT_SHIFT 291
#define RIGHT_SHIFT 292
#define EVAL 293
#define DECIDE 294
#define BOOL_VALUE 295
#define UNTIL 296
#define WHILE 297
#define RUN 298
#define CATCH 299
#define IS 300
#define ISOF 301
#define MAKE 302
#define METHOD_CALL 303
#define NULL_VALUE 304
#define DOCSTRING 305
#define BREAK 306
#define CONTINUE 307
#define RETURN 308
#define VERSION_KEYWORD 309
#define REGEX_VALUE 310
#define REGEX_VALUE_CI 311
#define ARRAY_SET 312
#define OPTIONS_SET 313




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 125 "kite_parser.y"

    double doubleValue;
    long intValue;
    char *stringValue;
    struct kite_object_t *internalValue;
    void *opValue;



/* Line 214 of yacc.c  */
#line 295 "kite_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 320 "kite_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  129
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   567

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  76
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  78
/* YYNRULES -- Number of rules.  */
#define YYNRULES  186
/* YYNRULES -- Number of states.  */
#define YYNSTATES  295

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   313

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    73,     2,     2,
      62,    63,    71,    69,    64,    70,    65,    72,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,    59,
      67,    66,    68,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    60,     2,    61,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    74,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     5,     9,    10,    16,    20,    21,
      23,    25,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    55,    58,    60,    62,    64,
      65,    67,    68,    77,    78,    85,    86,    88,    89,    91,
      94,    98,   101,   106,   107,   116,   117,   119,   122,   124,
     128,   129,   131,   133,   137,   139,   141,   143,   145,   147,
     149,   150,   158,   159,   166,   171,   172,   180,   181,   190,
     192,   194,   196,   198,   200,   202,   204,   206,   208,   210,
     212,   214,   216,   218,   220,   222,   224,   226,   228,   230,
     232,   234,   236,   238,   240,   242,   244,   246,   247,   252,
     254,   255,   260,   262,   266,   268,   269,   274,   276,   280,
     284,   286,   290,   294,   298,   302,   304,   308,   312,   316,
     320,   322,   326,   330,   332,   336,   340,   344,   346,   349,
     352,   355,   357,   361,   365,   366,   370,   372,   373,   379,
     384,   388,   390,   392,   393,   395,   398,   402,   404,   408,
     410,   414,   416,   418,   420,   422,   424,   428,   434,   436,
     438,   440,   442,   444,   448,   452,   455,   459,   461,   465,
     467,   468,   474,   476,   480,   481,   487,   488,   492,   497,
     498,   502,   503,   507,   508,   509,   510
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      77,     0,    -1,    -1,    -1,    50,    78,    77,    -1,    -1,
      54,    30,    59,    79,    77,    -1,    80,    59,    77,    -1,
      -1,   112,    -1,    81,    -1,   146,    -1,    98,    -1,    82,
      -1,    83,    -1,    84,    -1,    85,    -1,    95,    -1,   107,
      -1,   139,    -1,   150,    -1,   103,    -1,   105,    -1,   109,
      -1,    58,    30,    30,    -1,     3,    30,    -1,    51,    -1,
      52,    -1,    53,    -1,    -1,    50,    -1,    -1,     4,     5,
      92,    86,    88,    60,    77,    61,    -1,    -1,     4,    92,
      90,    60,    77,    61,    -1,    -1,    11,    -1,    -1,    93,
      -1,    62,    63,    -1,    62,    94,    63,    -1,     5,    86,
      -1,     5,    86,    64,    94,    -1,    -1,     7,     5,    96,
      97,    86,    60,   100,    61,    -1,    -1,    98,    -1,     6,
      99,    -1,     5,    -1,    99,    65,     5,    -1,    -1,   101,
      -1,   102,    -1,   101,    64,   102,    -1,   103,    -1,   105,
      -1,   107,    -1,   109,    -1,    95,    -1,   112,    -1,    -1,
       8,    92,   104,    86,    60,    77,    61,    -1,    -1,     9,
     106,    86,    60,    77,    61,    -1,    91,    10,     5,    86,
      -1,    -1,    91,    10,     5,    86,    66,   108,   112,    -1,
      -1,    34,   111,    93,   110,    86,    60,    77,    61,    -1,
      12,    -1,    13,    -1,    14,    -1,    15,    -1,    33,    -1,
      16,    -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,
      57,    -1,    21,    -1,    22,    -1,    23,    -1,    24,    -1,
      25,    -1,    26,    -1,    27,    -1,    28,    -1,    29,    -1,
      35,    -1,    36,    -1,    37,    -1,    48,    -1,    10,    -1,
     113,    -1,    87,    -1,   144,    -1,    -1,   128,   114,    66,
     112,    -1,   115,    -1,    -1,   117,   116,    28,   115,    -1,
     117,    -1,   117,    35,   118,    -1,   118,    -1,    -1,   120,
     119,    27,   118,    -1,   120,    -1,   120,    36,   121,    -1,
     120,    37,   121,    -1,   121,    -1,   121,    21,   122,    -1,
     121,    22,   122,    -1,   121,    45,   122,    -1,   121,    46,
     122,    -1,   122,    -1,   122,    67,   123,    -1,   122,    68,
     123,    -1,   122,    25,   123,    -1,   122,    26,   123,    -1,
     123,    -1,   123,    69,   124,    -1,   123,    70,   124,    -1,
     124,    -1,   124,    71,   125,    -1,   124,    72,   125,    -1,
     124,    73,   125,    -1,   125,    -1,    69,   125,    -1,    70,
     125,    -1,    29,   125,    -1,   126,    -1,   128,    18,   128,
      -1,   128,    19,   128,    -1,    -1,     5,   127,   131,    -1,
     128,    -1,    -1,   128,    74,     5,   129,   130,    -1,   128,
      60,   112,    61,    -1,   128,    65,     5,    -1,     5,    -1,
     134,    -1,    -1,   131,    -1,    62,    63,    -1,    62,   132,
      63,    -1,   112,    -1,   112,    64,   132,    -1,     5,    -1,
     133,    65,     5,    -1,    30,    -1,    32,    -1,    31,    -1,
      40,    -1,    49,    -1,    32,    75,    32,    -1,    32,    75,
      32,    75,    32,    -1,    55,    -1,    56,    -1,   136,    -1,
     135,    -1,    89,    -1,    62,   112,    63,    -1,    47,   133,
     131,    -1,    60,    61,    -1,    60,   137,    61,    -1,   138,
      -1,   138,    64,   137,    -1,   115,    -1,    -1,    39,   140,
      60,   141,    61,    -1,   142,    -1,   141,    64,   142,    -1,
      -1,   134,   143,    60,    77,    61,    -1,    -1,    38,   145,
     115,    -1,   147,    60,    77,    61,    -1,    -1,    42,   148,
     134,    -1,    -1,    41,   149,   134,    -1,    -1,    -1,    -1,
      43,   151,    60,    77,    61,   152,    44,   153,    60,    77,
      61,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   135,   135,   136,   136,   142,   142,   182,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   203,   223,   265,   271,   277,   284,
     287,   292,   292,   301,   301,   308,   311,   316,   321,   326,
     331,   336,   347,   361,   361,   370,   373,   377,   382,   387,
     394,   395,   398,   399,   402,   403,   404,   405,   406,   407,
     410,   410,   418,   418,   426,   431,   431,   440,   440,   448,
     451,   454,   457,   460,   463,   466,   469,   472,   475,   478,
     481,   484,   487,   490,   493,   496,   499,   502,   505,   508,
     511,   514,   517,   520,   525,   526,   527,   530,   530,   535,
     538,   538,   543,   546,   549,   552,   552,   557,   560,   563,
     566,   569,   572,   575,   578,   581,   584,   587,   590,   593,
     596,   599,   602,   605,   608,   611,   614,   617,   620,   623,
     626,   629,   632,   635,   638,   638,   644,   647,   647,   654,
     658,   663,   667,   672,   675,   680,   683,   688,   691,   696,
     707,   719,   723,   726,   729,   732,   735,   739,   743,   747,
     751,   752,   753,   754,   757,   762,   765,   768,   771,   776,
     779,   779,   786,   787,   790,   790,   797,   797,   804,   809,
     809,   815,   815,   823,   825,   827,   823
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IMPORT", "METHOD", "SYMBOL_NAME",
  "FROM", "CLASS", "CONSTRUCT", "DESTRUCT", "PROPERTY", "GLOBAL", "PLUS",
  "MINUS", "MULTIPLY", "DIVIDE", "UNARY_PLUS", "UNARY_MINUS", "MAP",
  "REDUCE", "ARRAY_DEREF", "EQUALS", "NOT_EQUALS", "LESS_THAN",
  "GREATER_THAN", "LESS_OR_EQUALS", "GREATER_OR_EQUALS", "AND", "OR",
  "NOT", "STRING_VALUE", "FLOAT_VALUE", "INT_VALUE", "MOD", "OPERATOR",
  "XOR", "LEFT_SHIFT", "RIGHT_SHIFT", "EVAL", "DECIDE", "BOOL_VALUE",
  "UNTIL", "WHILE", "RUN", "CATCH", "IS", "ISOF", "MAKE", "METHOD_CALL",
  "NULL_VALUE", "DOCSTRING", "BREAK", "CONTINUE", "RETURN",
  "VERSION_KEYWORD", "REGEX_VALUE", "REGEX_VALUE_CI", "ARRAY_SET",
  "OPTIONS_SET", "';'", "'['", "']'", "'('", "')'", "','", "'.'", "'='",
  "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "'|'", "':'", "$accept",
  "input", "$@1", "$@2", "statement", "options_set_statement",
  "import_statement", "break_statement", "continue_statement",
  "return_statement", "optional_docstring", "method_declaration", "$@3",
  "anon_method_declaration", "$@4", "optional_global",
  "optional_param_name_list", "param_name_list", "param_elements",
  "class_definition", "$@5", "optional_from", "from_statement",
  "variable_immediate", "class_body", "class_elements", "class_element",
  "constructor_definition", "$@6", "destructor_definition", "$@7",
  "property_definition", "$@8", "operator_definition", "$@9",
  "operator_type", "data_manipulation_statement", "assignment_statement",
  "@10", "or_statement", "@11", "xor_statement", "and_statement", "@12",
  "bitwise_statement", "equality_statement", "less_greater_statement",
  "add_sub_statement", "multdiv_statement", "unary_statement",
  "map_reduce_statement", "$@13", "deref_statement", "$@14",
  "optional_param_list", "param_list", "params_list", "var_name",
  "constant_statement", "construct_object_statement", "list_value",
  "list_elements", "list_element", "decide_statement", "$@15",
  "decide_contents", "decide_condition", "@16", "eval_statement", "$@17",
  "loop_statement", "loop_type", "@18", "@19", "run_catch_statement",
  "@20", "@21", "$@22", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    59,
      91,    93,    40,    41,    44,    46,    61,    60,    62,    43,
      45,    42,    47,    37,   124,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    76,    77,    78,    77,    79,    77,    77,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    81,    82,    83,    84,    85,    86,
      86,    88,    87,    90,    89,    91,    91,    92,    92,    93,
      93,    94,    94,    96,    95,    97,    97,    98,    99,    99,
     100,   100,   101,   101,   102,   102,   102,   102,   102,   102,
     104,   103,   106,   105,   107,   108,   107,   110,   109,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   112,   112,   112,   114,   113,   113,
     116,   115,   115,   117,   117,   119,   118,   118,   120,   120,
     120,   121,   121,   121,   121,   121,   122,   122,   122,   122,
     122,   123,   123,   123,   124,   124,   124,   124,   125,   125,
     125,   125,   126,   126,   127,   126,   126,   129,   128,   128,
     128,   128,   128,   130,   130,   131,   131,   132,   132,   133,
     133,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   135,   136,   136,   137,   137,   138,
     140,   139,   141,   141,   143,   142,   145,   144,   146,   148,
     147,   149,   147,   151,   152,   153,   150
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     0,     3,     0,     5,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     1,     1,     1,     0,
       1,     0,     8,     0,     6,     0,     1,     0,     1,     2,
       3,     2,     4,     0,     8,     0,     1,     2,     1,     3,
       0,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       0,     7,     0,     6,     4,     0,     7,     0,     8,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     4,     1,
       0,     4,     1,     3,     1,     0,     4,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     1,     2,     2,
       2,     1,     3,     3,     0,     3,     1,     0,     5,     4,
       3,     1,     1,     0,     1,     2,     3,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     3,     5,     1,     1,
       1,     1,     1,     3,     3,     2,     3,     1,     3,     1,
       0,     5,     1,     3,     0,     5,     0,     3,     4,     0,
       3,     0,     3,     0,     0,     0,    11
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,    37,   141,     0,     0,    37,    62,    36,     0,
     151,   153,   152,     0,   176,   170,   154,   181,   179,   183,
       0,   155,     3,    26,    27,    28,     0,   158,   159,     0,
       0,     0,     0,     0,     0,     0,    10,    13,    14,    15,
      16,    95,   162,     0,    17,    12,    21,    22,    18,    23,
       9,    94,    99,   102,   104,   107,   110,   115,   120,   123,
     127,   131,   136,   142,   161,   160,    19,    96,    11,     0,
      20,    25,    37,     0,    33,    38,     0,    48,    47,    43,
      60,    29,    37,   130,   136,     0,    93,    69,    70,    71,
      72,    74,    75,    76,    77,    78,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    73,    89,    90,    91,    92,
      79,     0,     0,     0,     0,     0,     0,   149,     0,     2,
       0,     0,   165,   169,     0,   167,     0,   128,   129,     1,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,    29,    29,    39,
       0,     0,     0,   135,     0,    45,    29,    30,     0,   156,
      67,   177,     0,   182,   180,     2,     0,   164,     4,     5,
      24,   166,     0,   163,     7,    29,   103,     0,   108,   109,
       0,   111,   112,   113,   114,   118,   119,   116,   117,   121,
     122,   124,   125,   126,   141,   132,   133,     0,   140,   137,
       0,     0,    31,    41,    40,     2,   145,   147,     0,    49,
      29,    46,     0,     2,     0,    29,   174,     0,   172,     0,
     150,     2,   168,    64,   101,   106,   139,   143,    98,   178,
       0,     0,     0,     0,   146,     0,     2,     0,   157,     0,
       0,   171,     0,   184,     6,    65,   138,   144,     2,    42,
      34,   148,    35,     0,    63,     2,     2,   173,     0,     0,
       0,    58,     0,    51,    52,    54,    55,    56,    57,    59,
      61,     0,     0,   185,    66,    32,    44,    35,    68,   175,
       0,    53,     2,     0,   186
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    34,   119,   231,    35,    36,    37,    38,    39,    40,
     168,    41,   240,    42,   161,    43,    74,    75,   160,    44,
     165,   220,    45,    78,   272,   273,   274,    46,   166,    47,
      81,    48,   269,    49,   225,   111,    50,    51,   155,    52,
     133,    53,    54,   136,    55,    56,    57,    58,    59,    60,
      61,    76,    84,   237,   256,   163,   218,   118,    63,    64,
      65,   124,   125,    66,   113,   227,   228,   250,    67,   112,
      68,    69,   115,   114,    70,   116,   268,   290
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -249
static const yytype_int16 yypact[] =
{
     267,    14,     4,   -45,    45,    62,    10,  -249,  -249,   418,
    -249,  -249,    -1,   510,  -249,  -249,  -249,  -249,  -249,  -249,
      81,  -249,  -249,  -249,  -249,  -249,    65,  -249,  -249,    67,
     338,   372,   418,   418,   105,    51,  -249,  -249,  -249,  -249,
    -249,  -249,  -249,   101,  -249,  -249,  -249,  -249,  -249,  -249,
    -249,  -249,  -249,    -8,  -249,    46,     1,     3,   -35,    20,
    -249,  -249,    24,  -249,  -249,  -249,  -249,  -249,  -249,    53,
    -249,  -249,    10,     2,  -249,  -249,    52,  -249,    56,  -249,
    -249,    68,    10,  -249,    41,    96,  -249,  -249,  -249,  -249,
    -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,
    -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,
    -249,    10,   418,    69,   459,   459,    71,  -249,   -47,   267,
      74,   104,  -249,  -249,    82,    80,    83,  -249,  -249,  -249,
     267,   140,   418,   121,   418,   418,   126,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     421,   421,   372,   152,   154,    94,   267,    68,    68,  -249,
      98,   106,   326,  -249,   159,   161,    68,  -249,   108,    90,
    -249,  -249,   459,  -249,  -249,   267,   166,  -249,  -249,  -249,
    -249,  -249,   418,  -249,  -249,    68,  -249,   418,     1,     1,
     418,     3,     3,     3,     3,   -35,   -35,   -35,   -35,    20,
      20,  -249,  -249,  -249,  -249,   -12,   -12,   116,  -249,  -249,
     372,   117,  -249,   115,  -249,   267,  -249,   118,   120,  -249,
      68,  -249,   124,   267,   153,    68,  -249,   -31,  -249,   125,
    -249,   267,  -249,   122,  -249,  -249,  -249,    52,  -249,  -249,
     127,   184,   129,   372,  -249,   131,   267,   132,  -249,   138,
     141,  -249,   459,  -249,  -249,  -249,  -249,  -249,   267,  -249,
    -249,  -249,    47,   139,  -249,   267,   267,  -249,   148,   372,
     143,  -249,   145,   144,  -249,  -249,  -249,  -249,  -249,  -249,
    -249,   146,   150,  -249,  -249,  -249,  -249,   165,  -249,  -249,
     142,  -249,   267,   155,  -249
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -249,  -111,  -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249,
    -145,  -249,  -249,  -249,  -249,  -249,    -3,   107,   -32,  -248,
    -249,  -249,    54,  -249,  -249,  -249,   -70,  -246,  -249,  -238,
    -249,  -230,  -249,  -226,  -249,  -249,   -30,  -249,  -249,   -24,
    -249,  -249,  -127,  -249,  -249,   -97,   -13,    -5,   -46,    -7,
    -249,  -249,     0,  -249,  -249,  -114,   -21,  -249,  -104,  -249,
    -249,    42,  -249,  -249,  -249,  -249,   -26,  -249,  -249,  -249,
    -249,  -249,  -249,  -249,  -249,  -249,  -249,  -249
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -135
static const yytype_int16 yytable[] =
{
      62,   126,    83,    80,   177,   186,   123,   158,   178,    72,
     173,   174,   212,   213,   271,   162,   275,  -134,   176,   184,
    -100,   222,   137,   138,   276,   127,   128,   132,   141,   142,
     251,    62,   277,   252,   145,   146,   278,   188,   189,   271,
     233,   275,   150,   151,    71,   211,   139,   140,   152,   276,
      77,     2,     3,   153,     5,     6,     7,   277,     8,   150,
     151,   278,   154,   235,   229,   159,    73,    79,   226,   157,
     143,   144,    73,  -105,    85,   245,     9,    10,    11,    12,
     249,    13,   134,   135,   152,    14,   117,    16,   171,   153,
     -97,   147,   148,   149,    20,   120,    21,   121,   154,   199,
     200,   152,    27,    28,   242,   129,   153,    30,   -50,    31,
     130,   131,   247,   156,   162,   154,    32,    33,   167,    62,
     254,   164,   207,   257,   191,   192,   193,   194,   169,   172,
      62,   175,   217,   179,   180,   263,   195,   196,   197,   198,
     201,   202,   203,   181,   182,   185,   183,   270,   226,   187,
     205,   206,    62,   190,   281,   282,    62,   208,   123,   209,
     210,   214,    62,   234,   219,   224,   215,     4,   223,     2,
       3,   230,     5,     6,     7,    62,     8,   236,   239,   241,
     238,   293,   243,   244,   246,   248,   253,   258,   255,   158,
     260,   262,   283,   264,     9,    10,    11,    12,   265,    13,
     280,   266,   292,    14,   285,    16,   286,   288,   287,   259,
      62,   289,    20,   217,    21,    62,   294,   291,   170,   221,
      27,    28,   261,    62,   232,    30,   267,    31,     0,     0,
       0,    62,   279,     0,    32,    33,     0,     0,     0,   284,
       0,     0,     0,    62,     0,     0,    62,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   279,    62,     0,
       0,     0,    62,     0,     0,    62,    62,     0,     0,    62,
       1,     2,     3,     4,     5,     6,     7,   -35,     8,     0,
       0,     0,     0,     0,     0,     0,     0,    62,     0,     0,
       0,     0,    62,     0,     0,     0,     9,    10,    11,    12,
       0,    13,     0,     0,     0,    14,    15,    16,    17,    18,
      19,     0,     0,     0,    20,     0,    21,    22,    23,    24,
      25,    26,    27,    28,     0,    29,    -8,    30,     0,    31,
       2,     3,     0,     0,     0,     0,    32,    33,     0,     0,
       0,     0,    82,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     9,    10,    11,    12,     0,
       0,     0,     0,     0,    14,     0,    16,     9,    10,    11,
      12,     0,     0,    20,     0,    21,     2,     3,    16,     0,
       0,    27,    28,     0,     0,    20,    30,    21,    31,   216,
       0,     0,     0,    27,    28,    32,    33,     0,    30,   122,
      31,     9,    10,    11,    12,     0,     0,    32,    33,     0,
      14,     0,    16,     0,     0,     0,     0,     0,     0,    20,
       0,    21,    82,     3,     0,    82,   204,    27,    28,     0,
       0,     0,    30,     0,    31,     0,     0,     0,     0,     0,
       0,    32,    33,     0,     0,     0,     0,     9,    10,    11,
      12,    10,    11,    12,     0,     0,     0,     0,    16,     0,
       0,    16,     0,    82,     0,    20,     0,    21,    20,     0,
      21,     0,     0,    27,    28,     0,    27,    28,    30,     0,
      31,    30,     0,    31,     0,     0,     0,    32,    33,    10,
      11,    12,     0,     0,     0,     0,     0,     0,     0,    16,
       0,     0,     0,     0,     0,     0,    20,     0,    21,     0,
       0,     0,     0,     0,    27,    28,     0,     0,     0,    30,
      86,    31,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
       0,     0,     0,   105,     0,   106,   107,   108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   109,     0,
       0,     0,     0,     0,     0,     0,     0,   110
};

static const yytype_int16 yycheck[] =
{
       0,    31,     9,     6,   118,   132,    30,     5,   119,     5,
     114,   115,   157,   158,   262,    62,   262,    62,    65,   130,
      28,   166,    21,    22,   262,    32,    33,    35,    25,    26,
      61,    31,   262,    64,    69,    70,   262,   134,   135,   287,
     185,   287,    18,    19,    30,   156,    45,    46,    60,   287,
       5,     4,     5,    65,     7,     8,     9,   287,    11,    18,
      19,   287,    74,   190,   175,    63,    62,     5,   172,    72,
      67,    68,    62,    27,    75,   220,    29,    30,    31,    32,
     225,    34,    36,    37,    60,    38,     5,    40,   112,    65,
      66,    71,    72,    73,    47,    30,    49,    30,    74,   145,
     146,    60,    55,    56,   215,     0,    65,    60,    61,    62,
      59,    10,   223,    60,    62,    74,    69,    70,    50,   119,
     231,    65,   152,   237,   137,   138,   139,   140,    32,    60,
     130,    60,   162,    59,    30,   246,   141,   142,   143,   144,
     147,   148,   149,    61,    64,     5,    63,   258,   252,    28,
     150,   151,   152,    27,   265,   266,   156,     5,   182,     5,
      66,    63,   162,   187,     5,    75,    60,     6,    60,     4,
       5,     5,     7,     8,     9,   175,    11,    61,    61,    64,
     210,   292,    64,    63,    60,    32,    61,    60,    66,     5,
      61,    60,    44,    61,    29,    30,    31,    32,    60,    34,
      61,    60,    60,    38,    61,    40,    61,    61,    64,   241,
     210,    61,    47,   243,    49,   215,    61,   287,   111,   165,
      55,    56,   243,   223,   182,    60,   252,    62,    -1,    -1,
      -1,   231,   262,    -1,    69,    70,    -1,    -1,    -1,   269,
      -1,    -1,    -1,   243,    -1,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   258,    -1,
      -1,    -1,   262,    -1,    -1,   265,   266,    -1,    -1,   269,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,
      -1,    -1,   292,    -1,    -1,    -1,    29,    30,    31,    32,
      -1,    34,    -1,    -1,    -1,    38,    39,    40,    41,    42,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    62,
       4,     5,    -1,    -1,    -1,    -1,    69,    70,    -1,    -1,
      -1,    -1,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    29,    30,    31,
      32,    -1,    -1,    47,    -1,    49,     4,     5,    40,    -1,
      -1,    55,    56,    -1,    -1,    47,    60,    49,    62,    63,
      -1,    -1,    -1,    55,    56,    69,    70,    -1,    60,    61,
      62,    29,    30,    31,    32,    -1,    -1,    69,    70,    -1,
      38,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    49,     4,     5,    -1,     4,     5,    55,    56,    -1,
      -1,    -1,    60,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    30,    31,    32,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    40,    -1,     4,    -1,    47,    -1,    49,    47,    -1,
      49,    -1,    -1,    55,    56,    -1,    55,    56,    60,    -1,
      62,    60,    -1,    62,    -1,    -1,    -1,    69,    70,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    55,    56,    -1,    -1,    -1,    60,
      10,    62,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    33,    -1,    35,    36,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    11,    29,
      30,    31,    32,    34,    38,    39,    40,    41,    42,    43,
      47,    49,    50,    51,    52,    53,    54,    55,    56,    58,
      60,    62,    69,    70,    77,    80,    81,    82,    83,    84,
      85,    87,    89,    91,    95,    98,   103,   105,   107,   109,
     112,   113,   115,   117,   118,   120,   121,   122,   123,   124,
     125,   126,   128,   134,   135,   136,   139,   144,   146,   147,
     150,    30,     5,    62,    92,    93,   127,     5,    99,     5,
      92,   106,     4,   125,   128,    75,    10,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    33,    35,    36,    37,    48,
      57,   111,   145,   140,   149,   148,   151,     5,   133,    78,
      30,    30,    61,   115,   137,   138,   112,   125,   125,     0,
      59,    10,    35,   116,    36,    37,   119,    21,    22,    45,
      46,    25,    26,    67,    68,    69,    70,    71,    72,    73,
      18,    19,    60,    65,    74,   114,    60,    92,     5,    63,
      94,    90,    62,   131,    65,    96,   104,    50,    86,    32,
      93,   115,    60,   134,   134,    60,    65,   131,    77,    59,
      30,    61,    64,    63,    77,     5,   118,    28,   121,   121,
      27,   122,   122,   122,   122,   123,   123,   123,   123,   124,
     124,   125,   125,   125,     5,   128,   128,   112,     5,     5,
      66,    77,    86,    86,    63,    60,    63,   112,   132,     5,
      97,    98,    86,    60,    75,   110,   134,   141,   142,    77,
       5,    79,   137,    86,   115,   118,    61,   129,   112,    61,
      88,    64,    77,    64,    63,    86,    60,    77,    32,    86,
     143,    61,    64,    61,    77,    66,   130,   131,    60,    94,
      61,   132,    60,    77,    61,    60,    60,   142,   152,   108,
      77,    95,   100,   101,   102,   103,   105,   107,   109,   112,
      61,    77,    77,    44,   112,    61,    61,    64,    61,    61,
     153,   102,    60,    77,    61
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 136 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_object_t *obj = kite_top_stack(compiler->obj_created);
        kite_set_docstring(obj, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 142 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        char *tmp;
        
        if (compiler->verMajor)
        {
            yyerror("Cannot specify required version more than once.");
            YYERROR;
        }
        
        compiler->verMajor = atoi((yyvsp[(2) - (3)].stringValue));
        tmp = strstr((yyvsp[(2) - (3)].stringValue), ".");
        if (!tmp)
        {
            yyerror("Parse error while reading version string");
            YYERROR;
        }
        compiler->verPatch = atoi(tmp);
        tmp = strstr(tmp, ".");
        if (!tmp)
        {
            compiler->verPatch = 0;
        }
        
        if (compiler->verMajor > VERSION_MAJOR ||
           (compiler->verMajor == VERSION_MAJOR && compiler->verMinor > VERSION_MINOR) ||
           (compiler->verMajor == VERSION_MAJOR && compiler->verMinor == VERSION_MINOR && compiler->verPatch > VERSION_PATCH))
        {
            char buf[1024];
#ifndef WIN32
            snprintf(buf, 1024, "Module can only run in Kite version %d.%d.%d and above.",
                    compiler->verMajor, compiler->verMinor, compiler->verPatch);
#else
            sprintf_s(buf, 1024, "Module can only run in Kite version %d.%d.%d and above.",
                    compiler->verMajor, compiler->verMinor, compiler->verPatch);
#endif /* WIN32 */
            yyerror(buf);
            YYERROR;    
        }
    }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 203 "kite_parser.y"
    {
    if (strcmp("import_path", (yyvsp[(2) - (3)].stringValue)) == 0)
    {
        /* TODO: thread safety */
        char *old_kite_dylib_path = kite_dylib_path;
#ifndef HAVE_GC_H
        kite_dylib_path = malloc(strlen(old_kite_dylib_path) + strlen((yyvsp[(3) - (3)].stringValue)) + 2);
#else
        kite_dylib_path = GC_malloc(strlen(old_kite_dylib_path) + strlen((yyvsp[(3) - (3)].stringValue)) + 2);
#endif
        strcpy(kite_dylib_path, old_kite_dylib_path);
        strcat(kite_dylib_path, ":");
        strcat(kite_dylib_path, (yyvsp[(3) - (3)].stringValue));
    }
    else
    {
        /* TODO: throw exception if no valid option found. */
    }
}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 223 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        kite_object_t *obj = kite_top_stack(compiler->obj_created);
        kite_opcode_t *opc;
        
#ifndef HAVE_GC_H
        kite_funccall_info_t *fcall = (kite_funccall_info_t*)malloc(sizeof(kite_funccall_info_t));
#else
        kite_funccall_info_t *fcall = (kite_funccall_info_t*)GC_malloc(sizeof(kite_funccall_info_t));
#endif /* HAVE_GC_H */        
        fcall->file = compiler->file;
        fcall->line = (yylsp[(2) - (2)]).first_line;
        fcall->locals = NULL;
        fcall->last_deref = NULL;
        fcall->last_deref_obj = NULL;
        fcall->sys_or_user = 0;
        fcall->this = obj;
        kite_push_stack(&thd->func_stack, FALSE, fcall);
        
        /* Skip over import statement when executing so that the code inside
           the import doesn't get executed twice. */
        COMPILE_INSTRUCTION2(thd, compiler, kite_compile_jump_uncond(NULL), (yylsp[(2) - (2)]).first_line, &obj->builtin_data.funcvalue.funcptr);
        opc = (void*)thd->vm->cur_text_segment - sizeof(kite_opcode_t);
        
        kite_dereference_and_load(thd, (yyvsp[(2) - (2)].stringValue));
        
        COMPILE_INSTRUCTION2(thd, compiler, kite_compile_nop(), (yylsp[(2) - (2)]).first_line, &obj->builtin_data.funcvalue.funcptr);
        opc = (void*)opc + (long)thd->vm->text_segment;
        opc->op_arg.jumpto = (void*)thd->vm->cur_text_segment - sizeof(kite_opcode_t);
        
        free((yyvsp[(2) - (2)].stringValue));

        if (thd->exception) return 0;
        
        kite_pop_stack(&thd->func_stack);
#ifndef HAVE_GC_H
        free(fcall);
#endif /* HAVE_GC_H */
    }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 266 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_BREAK])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 272 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CONTINUE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 278 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_RETURN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 284 "kite_parser.y"
    {
        (yyval.stringValue) = strdup("");
    }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 287 "kite_parser.y"
    {
        (yyval.stringValue) = (yyvsp[(1) - (1)].stringValue);
    }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 292 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_FUNC])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (4)]).first_line, (yyvsp[(3) - (4)].internalValue));
    }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 294 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_FUNC_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (8)]).first_line, (yyvsp[(2) - (8)].stringValue), (yyvsp[(4) - (8)].stringValue));
        free((yyvsp[(2) - (8)].stringValue));
        free((yyvsp[(4) - (8)].stringValue));
    }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 301 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_ANON_FUNC])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line, (yyvsp[(2) - (2)].internalValue));
    }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 303 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_ANON_FUNC_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(4) - (6)]).first_line);
    }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 308 "kite_parser.y"
    {
        (yyval.intValue) = 0;
    }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 311 "kite_parser.y"
    {
        (yyval.intValue) = 1;
    }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 316 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        (yyval.internalValue) = kite_new_list(thd);
    }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 321 "kite_parser.y"
    {
        (yyval.internalValue) = (yyvsp[(1) - (1)].internalValue);
    }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 326 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        (yyval.internalValue) = kite_new_list(thd);
    }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 331 "kite_parser.y"
    {
        (yyval.internalValue) = (yyvsp[(2) - (3)].internalValue);
    }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 336 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        checkReserved(parm, (yyvsp[(1) - (2)].stringValue));
        (yyval.internalValue) = kite_new_list(thd);
        (yyval.internalValue)->builtin_data.listvalue.car = 
            kite_new_ident(thd, (yyvsp[(1) - (2)].stringValue));
        kite_set_docstring((yyval.internalValue)->builtin_data.listvalue.car, (yyvsp[(2) - (2)].stringValue));
        free((yyvsp[(1) - (2)].stringValue));
        free((yyvsp[(2) - (2)].stringValue));
    }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 347 "kite_parser.y"
    {
        kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        checkReserved(parm, (yyvsp[(1) - (4)].stringValue));
        (yyval.internalValue) = kite_new_list(thd);
        (yyval.internalValue)->builtin_data.listvalue.car = 
            kite_new_ident(thd, (yyvsp[(1) - (4)].stringValue));
        (yyval.internalValue)->builtin_data.listvalue.cdr = (yyvsp[(4) - (4)].internalValue);
        kite_set_docstring((yyval.internalValue)->builtin_data.listvalue.car, (yyvsp[(2) - (4)].stringValue));
        free((yyvsp[(1) - (4)].stringValue));
        free((yyvsp[(2) - (4)].stringValue));
    }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 361 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_CLASS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line, (yyvsp[(2) - (2)].stringValue));
    }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 363 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CREATE_CLASS_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (8)]).first_line, (yyvsp[(2) - (8)].stringValue), (yyvsp[(5) - (8)].stringValue));
        free((yyvsp[(2) - (8)].stringValue));
        free((yyvsp[(5) - (8)].stringValue));
    }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 370 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_FROM_DEFAULT])((kite_compiler_t*)yyget_extra(parm), 0);
    }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 377 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_FROM_GIVEN_CLASS])((kite_compiler_t*)yyget_extra(parm), 0, (yyvsp[(2) - (2)].internalValue));
    }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 382 "kite_parser.y"
    {
        (yyval.internalValue) =
            (*kite_compiler_actions[COMPILE_IMMEDIATE_DEREF_1])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 387 "kite_parser.y"
    {
        (yyval.internalValue) =
            (*kite_compiler_actions[COMPILE_IMMEDIATE_DEREF_2])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (3)]).first_line, (yyvsp[(1) - (3)].internalValue), (yyvsp[(3) - (3)].stringValue));
        free((yyvsp[(3) - (3)].stringValue));
    }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 410 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CONSTRUCTOR])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line, (yyvsp[(2) - (2)].internalValue));
    }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 412 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CONSTRUCTOR_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (7)]).first_line, (yyvsp[(2) - (7)].internalValue), (yyvsp[(4) - (7)].stringValue));
        free((yyvsp[(4) - (7)].stringValue));
    }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 418 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DESTRUCTOR])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 420 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DESTRUCTOR_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (6)]).first_line, (yyvsp[(3) - (6)].stringValue));
        free((yyvsp[(3) - (6)].stringValue));
    }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 426 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_PROPERTY_CREATE_WITH_DEFAULT_VAL])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (4)]).first_line, (yyvsp[(1) - (4)].intValue), (yyvsp[(3) - (4)].stringValue), (yyvsp[(4) - (4)].stringValue));
        free((yyvsp[(3) - (4)].stringValue));
        free((yyvsp[(4) - (4)].stringValue));
    }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 431 "kite_parser.y"
    {
            (*kite_compiler_actions[COMPILE_PROPERTY_CREATE_WITH_SPECIFIED_VAL])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (5)]).first_line, (yyvsp[(1) - (5)].intValue), (yyvsp[(3) - (5)].stringValue), (yyvsp[(4) - (5)].stringValue));
            free((yyvsp[(3) - (5)].stringValue));
            free((yyvsp[(4) - (5)].stringValue));
        }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 435 "kite_parser.y"
    {
            (*kite_compiler_actions[COMPILE_PROPERTY_CREATE_WITH_SPECIFIED_VAL_RHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(5) - (7)]).first_line);
        }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 440 "kite_parser.y"
    {
    (*kite_compiler_actions[COMPILE_OPERATOR])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line, (yyvsp[(3) - (3)].internalValue));
}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 442 "kite_parser.y"
    {
    (*kite_compiler_actions[COMPILE_OPERATOR_BODY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (8)]).first_line, (yyvsp[(2) - (8)].intValue), (yyvsp[(5) - (8)].stringValue));
    free((yyvsp[(5) - (8)].stringValue));
}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 448 "kite_parser.y"
    {
        (yyval.intValue) = OP_ADD;
    }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 451 "kite_parser.y"
    {
        (yyval.intValue) = OP_SUBTRACT;
    }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 454 "kite_parser.y"
    {
        (yyval.intValue) = OP_MULTIPLY;
    }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 457 "kite_parser.y"
    {
        (yyval.intValue) = OP_DIVIDE;
    }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 460 "kite_parser.y"
    {
        (yyval.intValue) = OP_MODULUS;
    }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 463 "kite_parser.y"
    {
        (yyval.intValue) = OP_UNARY_PLUS;
    }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 466 "kite_parser.y"
    {
        (yyval.intValue) = OP_UNARY_MINUS;
    }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 469 "kite_parser.y"
    {
        (yyval.intValue) = OP_MAP;
    }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 472 "kite_parser.y"
    {
        (yyval.intValue) = OP_REDUCE;
    }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 475 "kite_parser.y"
    {
        (yyval.intValue) = OP_ARRAY_DEREF;
    }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 478 "kite_parser.y"
    {
        (yyval.intValue) = OP_ARRAY_SET;
    }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 481 "kite_parser.y"
    {
        (yyval.intValue) = OP_EQUALS;
    }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 484 "kite_parser.y"
    {
        (yyval.intValue) = OP_NOT_EQUALS;
    }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 487 "kite_parser.y"
    {
        (yyval.intValue) = OP_LESS_THAN;
    }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 490 "kite_parser.y"
    {
        (yyval.intValue) = OP_GREATER_THAN;
    }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 493 "kite_parser.y"
    {
        (yyval.intValue) = OP_LESS_OR_EQUALS;
    }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 496 "kite_parser.y"
    {
        (yyval.intValue) = OP_GREATER_OR_EQUALS;
    }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 499 "kite_parser.y"
    {
        (yyval.intValue) = OP_AND;
    }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 502 "kite_parser.y"
    {
        (yyval.intValue) = OP_OR;
    }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 505 "kite_parser.y"
    {
        (yyval.intValue) = OP_NOT;
    }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 508 "kite_parser.y"
    {
        (yyval.intValue) = OP_XOR;
    }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 511 "kite_parser.y"
    {
        (yyval.intValue) = OP_LEFT_SHIFT;
    }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 514 "kite_parser.y"
    {
        (yyval.intValue) = OP_RIGHT_SHIFT;
    }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 517 "kite_parser.y"
    {
        (yyval.intValue) = OP_METHOD_CALL;
    }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 520 "kite_parser.y"
    {
        (yyval.intValue) = OP_PROPERTY;
    }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 530 "kite_parser.y"
    {
    (yyval.opValue) = (*kite_compiler_actions[COMPILE_ASSIGNMENT_LHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 532 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ASSIGNMENT_RHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (4)]).first_line, (yyvsp[(1) - (4)].opValue), (yyvsp[(2) - (4)].opValue));
    }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 538 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_OR_LHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 540 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_OR_RHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (4)]).first_line, (yyvsp[(2) - (4)].opValue));
    }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 546 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_XOR])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 552 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_AND_LHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 554 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_AND_RHS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (4)]).first_line, (yyvsp[(2) - (4)].opValue));
    }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 560 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_LEFT_SHIFT])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 563 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_RIGHT_SHIFT])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 569 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_EQUALS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 572 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_NOT_EQUALS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 575 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_IS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 578 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ISOF])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 584 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_LESS_THAN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 587 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_GREATER_THAN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 590 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_LESS_EQUALS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 593 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_GREATER_EQUALS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 599 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ADD])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 602 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_SUBTRACT])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 608 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_MULTIPLY])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 611 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DIVIDE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 614 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_MODULUS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 620 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_UNARY_PLUS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line);
    }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 623 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_UNARY_MINUS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line);
    }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 626 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_NOT])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line);
    }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 632 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_MAP])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 635 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_REDUCE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 638 "kite_parser.y"
    { 
        (*kite_compiler_actions[COMPILE_FUNC_CALL_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 641 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_FUNC_CALL_ARGS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line);
    }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 647 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DEREF_AND_CALL_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line, (yyvsp[(3) - (3)].stringValue));
        free((yyvsp[(3) - (3)].stringValue));
    }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 650 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DEREF_AND_CALL_ARGS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (5)]).first_line, (yyvsp[(5) - (5)].opValue));
        (yyval.opValue) = (yyvsp[(1) - (5)].opValue);
    }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 654 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ARRAY_DEREF])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (4)]).first_line);
        (yyval.opValue) = (yyvsp[(1) - (4)].opValue);
    }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 658 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DEREF_2])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (3)]).first_line, (yyvsp[(3) - (3)].stringValue));
        free((yyvsp[(3) - (3)].stringValue));
        (yyval.opValue) = (yyvsp[(1) - (3)].opValue);
    }
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 663 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_DEREF_1])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 667 "kite_parser.y"
    {
        (yyval.opValue) = (yyvsp[(1) - (1)].opValue);
    }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 672 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_EMPTY_PARAM_LIST])((kite_compiler_t*)yyget_extra(parm), (yylsp[(0) - (0)]).first_line);
    }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 675 "kite_parser.y"
    {
        (yyval.opValue) = (yyvsp[(1) - (1)].opValue);
    }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 680 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_EMPTY_PARAM_LIST])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line);
    }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 683 "kite_parser.y"
    {
        (yyval.opValue) = (yyvsp[(2) - (3)].opValue);
    }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 688 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_SINGLE_FUNC_PARAM])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 691 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_COMBINE_FUNC_PARAMS])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 696 "kite_parser.y"
    {
        /*kite_compiler_t *compiler = (kite_compiler_t*)yyget_extra(parm);
        kite_thread_t *thd = compiler->thd;
        kite_opcode_t *op = kite_compile_push(kite_new_ident(thd, $<stringValue>1));
        COMPILE_INSTRUCTION(op, @1.first_line);
        COMPILE_INSTRUCTION(kite_compile_deref_1(TRUE), @1.first_line);
        free($<stringValue>1);
        $<opValue>$ = op;*/
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_DEREF_1])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 707 "kite_parser.y"
    {
        /*COMPILE_INSTRUCTION(kite_compile_push(kite_new_ident(thd, $<stringValue>3)),
             @2.first_line);
        COMPILE_INSTRUCTION(kite_compile_deref_2(), @2.first_line);
        free($<stringValue>3);
        $<opValue>$ = $<opValue>1;*/
        (*kite_compiler_actions[COMPILE_DEREF_2])((kite_compiler_t*)yyget_extra(parm), (yylsp[(3) - (3)]).first_line, (yyvsp[(3) - (3)].stringValue));
        free((yyvsp[(3) - (3)].stringValue));
        (yyval.opValue) = (yyvsp[(1) - (3)].opValue);
    }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 719 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_STRING])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue));
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 723 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_INTEGER])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].intValue));
    }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 726 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_FLOAT])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].doubleValue));
    }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 729 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_BOOL])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].intValue));
    }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 732 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_NULL])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 736 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_RANGE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line, (yyvsp[(1) - (3)].intValue), (yyvsp[(3) - (3)].intValue), 1);
    }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 740 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_RANGE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (5)]).first_line, (yyvsp[(1) - (5)].intValue), (yyvsp[(3) - (5)].intValue), (yyvsp[(5) - (5)].intValue));
    }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 743 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_REGEX])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue), FALSE);
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 747 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_CONSTANT_REGEX])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line, (yyvsp[(1) - (1)].stringValue), TRUE);
        free((yyvsp[(1) - (1)].stringValue));
    }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 751 "kite_parser.y"
    { (yyval.opValue) = NULL; }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 752 "kite_parser.y"
    { (yyval.opValue) = NULL; }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 753 "kite_parser.y"
    { (yyval.opValue) = NULL; }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 754 "kite_parser.y"
    { (yyval.opValue) = NULL; }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 757 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_MAKE])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line);
    }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 762 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ZERO_ELEMENT_LIST])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (2)]).first_line);
    }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 768 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_ONE_ELEMENT_LIST])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 771 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_TWO_ELEMENT_LIST])((kite_compiler_t*)yyget_extra(parm), (yylsp[(2) - (3)]).first_line);
    }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 779 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DECIDE_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 781 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DECIDE_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(5) - (5)]).first_line);
    }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 790 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_DECIDE_CONDITION_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 792 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_DECIDE_CONDITION_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(5) - (5)]).first_line, (yyvsp[(2) - (5)].opValue));
    }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 797 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_EVAL_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 799 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_EVAL_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line);
    }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 804 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_LOOP_WRAPPER])((kite_compiler_t*)yyget_extra(parm), (yylsp[(4) - (4)]).first_line, (yyvsp[(1) - (4)].opValue));
    }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 809 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_WHILE_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 811 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_WHILE_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line);
        (yyval.opValue) = (yyvsp[(2) - (3)].opValue);
    }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 815 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_UNTIL_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 817 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_UNTIL_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (3)]).first_line);
        (yyval.opValue) = (yyvsp[(2) - (3)].opValue);
    }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 823 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_RUN_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (1)]).first_line);
    }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 825 "kite_parser.y"
    {
        (yyval.opValue) = (*kite_compiler_actions[COMPILE_RUN_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(1) - (5)]).first_line);
    }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 827 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CATCH_BEGIN])((kite_compiler_t*)yyget_extra(parm), (yylsp[(7) - (7)]).first_line, (yyvsp[(2) - (7)].opValue));
    }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 829 "kite_parser.y"
    {
        (*kite_compiler_actions[COMPILE_CATCH_END])((kite_compiler_t*)yyget_extra(parm), (yylsp[(7) - (11)]).first_line, (yyvsp[(6) - (11)].opValue));
    }
    break;



/* Line 1455 of yacc.c  */
#line 3285 "kite_parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 834 "kite_parser.y"


void dirty_yyerror(void *yyparse_param, char *str) {
    kite_object_t *exc;
    kite_compiler_t *comp = (kite_compiler_t*)yyget_extra(yyparse_param);
    kite_thread_t *thd = comp->thd;
    
    kite_funccall_info_t *entry = calloc(sizeof(kite_funccall_info_t), 1);
    entry->this = NULL;
    entry->file = comp->file;
    entry->line = comp->currentLine;
    kite_push_stack(&thd->func_stack, FALSE, entry);

    exc = kite_new_exception(thd, "System.exceptions.SyntaxError", 
                             str);
    kite_vm_call_method(thd, exc, "throw", kite_new_list(thd), TRUE);    
}

void checkReserved(void *p, char *name) {
    if (!strcmp(name, "__exc") ||
        !strcmp(name, "this")) {
        dirty_yyerror(p, "Cannot use reserved names for parameters.");
    }
}

